
Object subclass: #GradingApp2
  instanceVariableNames: 
    'allStudents commandChar '
  classVariableNames: ''
  poolDictionaries: ''    !


!GradingApp2 class methods !
 
example
    self new openOn: Dictionary new! !



!GradingApp2 methods !
   
addStudents

    | inName aStudent |

    [inName := Prompter prompt: 'Enter student''s name?' default: ''.
    inName = nil or: [inName = '']]
        whileFalse: [
            (allStudents includesKey: inName)
                ifTrue:
                    [Menu message: inName, ' already in database.']
                ifFalse: [
                    aStudent := Student new init.
                    aStudent name: inName.
                    allStudents at: inName put: aStudent] ]!
   
addTestScores

    | inName inScore aStudent |

    inName := Prompter prompt: 'Enter student''s name?' default: ''.
    (inName = nil or: [inName = '']) ifTrue: [^self].

    (allStudents includesKey: inName)
        ifFalse: [^Menu message: inName, ' not in database.'].

    aStudent := allStudents at: inName.

    [inScore := Prompter prompt: 'Score?' defaultExpression: ''.
    inScore = nil]
        whileFalse: [aStudent addScore: inScore]!
  
displayClassAverage

    | classSize sum classAverage |

    classSize := allStudents size.
    classSize = 0 ifTrue: [
        ^Menu message: 'There are no students in the class.'].

    sum :=0.0.
    allStudents do: [:aStudent | sum := sum + aStudent average].
    classAverage := sum / classSize.

    Menu message: 'The average for ', classSize printString,
                               ' students is ', classAverage printString!
   
displayStudentGrades

    | inName inScore aStudent |

    inName := Prompter prompt: 'Enter student''s name?' default: ''.
    (inName = nil or: [inName = '']) ifTrue: [^self].

    (allStudents includesKey: inName)
        ifFalse: [^Menu message: inName, ' not in database.'].

    aStudent := allStudents at: inName.
    Menu message: aStudent asString!

openOn: aDictionary

    | menuCommand |
    allStudents := aDictionary.
    self welcomeUser.

    [menuCommand := self popUpMenu.
    menuCommand = #exit]
        whileFalse: [
            menuCommand isNil
                ifFalse: [self perform: menuCommand] ]!
  
popUpMenu

    | menu |
    menu :=  Menu
                      labels: (       'Add &Students\',
                                          'Add &Test Scores\',
                                          'Display Class &Average\',
                                          'Display Student &Grades\',
                                          'Ha&lt\',
                                          '&Help\',
                                          '&Exit') withCrs
                     selectors: #( addStudents
                                          addTestScores
                                          displayClassAverage
                                          displayStudentGrades
                                          halt
                                          welcomeUser
                                          exit).
    ^menu popUp!
 
welcomeUser

    | welcomeStr |

    welcomeStr :=
             '-----Quick Grades----- \\',
             'A menu driven system for recording student ',
             ' test scores and assigning grades.\\',
             'To use the system  select  options from the pop up menu.'.
    Menu message: welcomeStr withCrs! !
