
WindowDialog subclass: #ApplicantDlg
  instanceVariableNames: 
    'applicant nameField ageField favoriteOSCombo education languages '
  classVariableNames: ''
  poolDictionaries: ''    !


!ApplicantDlg class methods !

example1

    "    ApplicantDlg example1   "

    ApplicantDlg new openOn: Applicant new! !



!ApplicantDlg methods !
  
cancel: aButton
    self mainView close.!
  
checkClicked: aButton

    (aButton selection = true)
        ifTrue: [ languages add: aButton contents]
        ifFalse: [languages remove: aButton contents]!
 
initWindowSize

    ^230@150!
 
ok: aButton

    | name ageStr  |

    name := nameField contents trimBlanks.
    nameField contents: name.
    (name = '')
        ifTrue: [^Menu message: 'A name is required'].

    ageStr := ageField contents trimBlanks.
    ageField contents: ageStr.
    (ageStr = '')
        ifTrue: [^Menu message: 'An age is required'].
    ageStr do: [ :chr | chr isDigit
                                    ifFalse: [^Menu message: 'Age must be a positive integer']].
    (ageStr asInteger = 0)
        ifTrue: [^Menu message: 'The age must be nonzero'].

    (education = '')
        ifTrue: [^Menu message: 'Education level is required'].

    applicant name: name;
                    age: ageStr asInteger;
                    education: education;
                    favoriteOS: favoriteOSCombo text;
                    languages: languages.

    self mainView close.!
 
openOn: anApplicant

     applicant := anApplicant.
     education := applicant education.
     languages := applicant languages copy.

     self label: 'Applicant Dialog'.

     self addSubpane:
        (StaticText new
            contents: 'Name';
            framingBlock: [:box | 10 @ 10 extent: 30 @ 10]).
    self addSubpane:
        (nameField := EntryField new      "for name"
            contents: applicant name;
            framingBlock: [:box | 40 @ 10 extent: 55 @ 12]).

     self addSubpane:
        (StaticText new
            contents: 'Age';
            framingBlock: [:box | 10 @ 25 extent: 30 @ 10]).
    self addSubpane:
        (ageField := EntryField new      "for age"
            contents: applicant age printString;
            setTextLimit: 2;
            framingBlock: [:box | 40 @ 25 extent: 20 @ 12]).

     self addSubpane:
        (StaticText new
            contents: 'Favorite OS (was ', applicant favoriteOS, ')';
            framingBlock: [:box | 120 @ 10 extent: 110 @ 20]).
    self addSubpane:
        (favoriteOSCombo := ComboBox new
          contents: #( 'Unix' 'Winows 95' 'Mac' 'VMS' 'OS 2 Warp' );
           framingBlock: [:box | 120 @ 25 extent: 55 @50] ).

     self addSubpane:
        (GroupBox new
           contents: 'Educational Level';
            framingBlock: [:box | 10 @ 40 extent: 100 @ 55] ).
    self addSubpane:
        (RadioButton new
            owner: self;
            contents: 'BA';
            when: #clicked perform: #radioClicked:;
            selection: (applicant education = 'BA');
            framingBlock: [:box | 15 @ 50 extent: 40 @ 10] ).
    self addSubpane:
        (RadioButton new
            owner: self;
            contents: 'MA';
            when: #clicked perform: #radioClicked:;
            selection: (applicant education = 'MA');
            framingBlock: [:box | 15 @ 60 extent: 40 @ 10] ).
   self addSubpane:
        (RadioButton new
            owner: self;
            contents: 'PhD';
            when: #clicked perform: #radioClicked:;
            selection: (applicant education = 'PhD');
            framingBlock: [:box | 15 @ 70 extent: 40 @ 10] ).
    self addSubpane:
        (RadioButton new
            owner: self;
            contents: 'No college degree';
            when: #clicked perform: #radioClicked:;
            selection: (applicant education = 'No college degree');
            framingBlock: [:box | 15 @ 80 extent: 80 @ 10] ).

     self addSubpane:
        (GroupBox new
           contents: 'Languages';
            framingBlock: [:box | 120 @ 40 extent: 100 @ 55] ).
    self addSubpane:
        (CheckBox new
            owner: self;
            contents: 'COBOL';
            when: #clicked perform: #checkClicked:;
            selection: (applicant languages includes: 'COBOL');
            framingBlock: [:box | 135 @ 50 extent: 40 @ 10] ).
    self addSubpane:
        (CheckBox new
            owner: self;
            contents: 'Pascal';
            when: #clicked perform: #checkClicked:;
            selection: (applicant languages includes:  'Pascal');
            framingBlock: [:box | 135 @ 60 extent: 40 @ 10] ).
   self addSubpane:
        (CheckBox new
            owner: self;
            contents: 'Smalltalk';
            when: #clicked perform: #checkClicked:;
            selection: (applicant languages includes: 'Smalltalk');
            framingBlock: [:box | 135 @ 70 extent: 40 @ 10] ).
    self addSubpane:
        (CheckBox new
            owner: self;
            contents: 'C++';
            when: #clicked perform: #checkClicked:;
            selection: (applicant languages includes: 'C++');
            framingBlock: [:box | 135 @ 80 extent: 80 @ 10] ).

    self addSubpane:
        (Button new
            defaultPushButton;
            owner: self;
            contents: 'OK';
            when: #clicked perform: #ok:;
            framingBlock: [:box | 70 @110 extent: 30 @ 13]).
    self addSubpane:
        (Button new
            owner: self;
            contents: 'Cancel';
            when: #clicked perform: #cancel:;
            framingBlock: [:box | 130 @110 extent: 30 @ 13]).
    self openWindow!

radioClicked: aButton

    education := aButton contents!
 
setFavoriteOSCombo: aDataEntryField

    aDataEntryField contents: 'abcd'.
    favoriteOSCombo text: applicant favoriteOS! !
