
Object subclass: #Bank
  instanceVariableNames: 
    'accounts customers nextAccountNumber '
  classVariableNames: ''
  poolDictionaries: ''  !


!Bank class methods !

new
    ^super new init! !



!Bank methods !
  
accountAsString: acctNumStr
    | account customer str |
    account := accounts at: acctNumStr.
    customer := account customer.
    ^str := (customer asString, account asString) withCrs!
   
accountNumbers

    ^accounts keys!
   
at: acctNumStr deposit: aNumber
   | account |
   account := accounts at: acctNumStr.
   account deposit: aNumber!
   
at: nameStr putAcct: acctStr
    | account accountNumber |
    acctStr = 'SV' ifTrue: [account := SavingsAccount new].
    acctStr = 'CK' ifTrue: [account := CheckingAccount new].
    acctStr = 'CG' ifTrue: [account := ChargeAccount new].
    accountNumber := acctStr, self nextAccountNumber printString.
    account init.
    account accountNumber: accountNumber.
    account customer: (customers at: nameStr).
    accounts at: accountNumber put: account.
    ^account accountNumber!
  
at: nameStr putAddr: addressStr
    | customer |
    (customers includesKey: nameStr)
        ifTrue: [^'duplicate'].
    customer := Customer new init.
    customer name: nameStr;
                    address: addressStr.
    customers at: nameStr put: customer.
    ^'done'!
 
at: nameStr updateCustomer: aCustomer

    customers removeKey: nameStr.
    customers at: aCustomer name put: aCustomer!

at: acctNumStr withdraw: aNumber

    | account |
    account := accounts at: acctNumStr.
    ^account withdraw: aNumber!
   
atName: nameStr

    ^customers at: nameStr!
  
customerAsString: nameStr

    | account customer str |
    customer := customers at: nameStr.
    str := customer asString.
    accounts do: [:acc |
        acc customer = customer
            ifTrue: [ str := str, acc asString]].
    ^str!
   
customerNames
    ^customers keys!
 
endOfMonthProcessing
    accounts do: [:acc | acc monthlyChargeOrInterest]!

init
    accounts := Dictionary new.
    customers := Dictionary new.
    nextAccountNumber := 99.!
  
nextAccountNumber
    ^nextAccountNumber := nextAccountNumber + 1!
 
nextAccountNumber: anInteger
    nextAccountNumber := anInteger!
   
removeAcct: acctNumStr
    accounts removeKey: acctNumStr!
 
removeCus: nameStr
    | customer tempAccounts |
    customer := customers at: nameStr.
    customers removeKey: nameStr.
    tempAccounts := accounts reject: [:acc | acc customer = customer].
    accounts := tempAccounts.! !
