
BankAccount subclass: #CheckingAccount
  instanceVariableNames: 
    'numberOfChecksBelowCutoff numberOfBadChecks '
  classVariableNames: 
    'BadCheckCharge ChargePerCheck FreeCheckCutoff '
  poolDictionaries: ''   !


!CheckingAccount class methods !
 
badCheckCharge: aNumber
    BadCheckCharge := aNumber!
 
chargePerCheck: aNumber
    ChargePerCheck := aNumber!
 
freeCheckCutoff: aNumber
    FreeCheckCutoff := aNumber!
   
new
    ^super new init! !



!CheckingAccount methods !
   
asString
    ^(super asString, '   number of bad checks: ',
                                         numberOfBadChecks printString,
                                '\', '   number of checks below cutoff: ',
                                         numberOfChecksBelowCutoff printString, '\') withCrs!

init
    super init.
    numberOfBadChecks := 0.
    numberOfChecksBelowCutoff := 0.
    BadCheckCharge isNil ifTrue: [BadCheckCharge := 15.00].
    ChargePerCheck isNil ifTrue: [ChargePerCheck := 0.25].
    FreeCheckCutoff isNil ifTrue: [FreeCheckCutoff := 300.00].!
   
monthlyChargeOrInterest
    | charge |
    charge := (numberOfBadChecks * BadCheckCharge) +
        (numberOfChecksBelowCutoff * ChargePerCheck).
    numberOfBadChecks := 0.
    numberOfChecksBelowCutoff := 0.
    balance := balance - charge!

withdraw: aNumber
    | outcome |
    outcome := super withdraw: aNumber.
    outcome = 'accepted'
        ifFalse: [numberOfBadChecks := numberOfBadChecks + 1]
        ifTrue: [balance < FreeCheckCutoff
            ifTrue: [numberOfChecksBelowCutoff
                := numberOfChecksBelowCutoff + 1]].
    ^outcome! !
