
BankAccount subclass: #ChargeAccount
  instanceVariableNames: 
    'paymentsForMonth previousBalance '
  classVariableNames: 
    'FinanceChargeRate CreditLimit '
  poolDictionaries: ''    !


!ChargeAccount class methods !
   
creditLimit: aNumber
    CreditLimit:= aNumber!

financeChargeRate: aNumber
    FinanceChargeRate := aNumber!
   
new
    ^super new init! !



!ChargeAccount methods !
 
asString
    ^(super asString, '   previous balance: ',
                                         previousBalance asDollarsAndCents,
                                '\', '   payments for month: ',
                                         paymentsForMonth asDollarsAndCents, '\') withCrs!
  
deposit: aNumber
    super deposit: aNumber.
    paymentsForMonth := paymentsForMonth + aNumber!
  
init
    super init.
    paymentsForMonth:= 0.00.
    previousBalance := 0.00.
    CreditLimit isNil ifTrue: [CreditLimit := 2000.00].
    FinanceChargeRate isNil ifTrue: [FinanceChargeRate := 0.18].!
   
monthlyChargeOrInterest
    | charge |
    charge := ((previousBalance + paymentsForMonth) min: 0)
        * FinanceChargeRate / 12.
    balance := balance + charge.
    paymentsForMonth := 0!
   
withDraw: aNumber
    (balance - aNumber) < (-1 * CreditLimit)
        ifTrue: [^'not accepted'].
    balance := balance - aNumber.
    ^'accepted'! !
