
Object subclass: #BankAccount
  instanceVariableNames: 
    'accountNumber balance customer '
  classVariableNames: ''
  poolDictionaries: '' !


!BankAccount class methods !
 
fileInOn: aStream
"Inputs the account's data into an account."
    | account className |
    className := aStream nextLine.
    className = 'SavingsAccount'
        ifTrue: [account := SavingsAccount fileInOn: aStream]
        ifFalse: [className = 'CheckingAccount'
            ifTrue: [account := CheckingAccount fileInOn: aStream]
            ifFalse: [account := ChargeAccount fileInOn: aStream]].
    account
        customer: aStream nextLine;		"Get name now; find customer"
        accountNumber: aStream nextLine;	"later."
        balance: aStream nextLine asFloat.
    ^account!

new
    ^super new init! !



!BankAccount methods !
   
accountNumber
    ^accountNumber!
  
accountNumber: aString
    accountNumber := aString!
   
asString
    ^(' ', (self class name), ' #', accountNumber, '\',
        '   balance: ', balance asDollarsAndCents, '\') withCrs!
 
balance: aValue
    balance := aValue!
 
customer
    ^customer!

customer: aString
    customer := aString!
 
deposit: aNumber
    balance := balance + aNumber!
 
fileOutOn: aStream
"Outputs the bank account's data to aStream."
    aStream
        nextPutAll: customer name; cr;
        nextPutAll: accountNumber; cr;
        nextPutAll: balance printString; cr!

init
    customer := 'Noneyet'.
    accountNumber := String new.
    balance := 0.00!

monthlyChargeOrInterest
    ^self implementedBySubclass!
   
withdraw: aNumber
    balance < aNumber ifTrue: [^'not accepted'].
    balance := balance - aNumber.
    ^'accepted'! !
