
ViewManager subclass: #BankInterface
  instanceVariableNames: 
    'bank selectedName selectedAccountNumber fileName '
  classVariableNames: ''
  poolDictionaries: 
    'ColorConstants WBConstants '   !


!BankInterface class methods !
   
example1
         " BankInterface example1 "

    |  bank |

    ChargeAccount creditLimit: 1000.00;
                        financeChargeRate: 0.24.
    CheckingAccount badCheckCharge: 15.00;
                        chargePerCheck: 0.25;
                        freeCheckCutoff: 300.00.
    SavingsAccount interestRate: 0.04.

    bank := Bank new.
    bank at: 'Bill' putAddr: '230 Briar';
             at: 'Paul' putAddr: '101 Pine'.
    bank at: 'Bill' putAcct: 'SV';
             at: 'Bill' putAcct: 'CK';
             at: 'Bill' putAcct: 'CG';
             at: 'Paul' putAcct: 'SV';
             at: 'Paul' putAcct: 'CK';
             at: 'Paul' putAcct: 'CG'.
     self new openOn: bank!
 
wbCreated

    ^true! !



!BankInterface methods !
   
addAccount: acctNumStr
    selectedAccountNumber := bank at: selectedName putAcct: acctNumStr.
    self
        changed: #displayText:;
        changed: #getAccountList:;
        changed: #getCustomerList:;
        enableDisableMenuItems!

addChargeAccount
    self addAccount: 'CG'!

addCheckingAccount
    self addAccount: 'CK'!
  
addCustomer

    |name address|
    self textModified.

    name := Prompter prompt: 'Name' default: ''.
    name isNil ifTrue: [^nil].
    address := Prompter prompt: 'Address' default: ''.

    (bank at: name putAddr: address) = 'duplicate'
        ifTrue: [^Menu message: name, ' already present'].

    selectedName := name.
    selectedAccountNumber := nil.

    self
        changed: #getCustomerList:;
        changed: #getAccountList:;
        changed: #displayText:;
        enableDisableMenuItems!
  
addSavingsAccount
    self addAccount: 'SV'!
   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Banking System';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 896 @ 592; xC; yC; cRDU: (9 @ 584 rightBottom: 887 @ 84));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 176; lDU: 46 r: #left; rDU: 274 r: #left; tDU: 56 r: #top; bDU: 232 r: #top);
                    defaultStyle;
                    startGroup;
                    when: #getContents perform: #getCustomerList:;
                    when: #select perform: #selectCustomer:;
                    yourself
            );
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 176; lDU: 46 r: #left; rDU: 274 r: #left; tDU: 312 r: #top; bDU: 488 r: #top);
                    defaultStyle;
                    startGroup;
                    when: #getContents perform: #getAccountList:;
                    when: #select perform: #selectAccount:;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 32; lDU: 73 r: #left; rDU: 247 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Customers';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 87 r: #left; rDU: 233 r: #left; tDU: 264 r: #top; bDU: 296 r: #top);
                    startGroup;
                    contents: 'Accounts';
                    yourself
            );
            addSubpane: (
                TextPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 472; lDU: 366 r: #left; rDU: 832 r: #left; tDU: 16 r: #top; bDU: 488 r: #top);
                    startGroup;
                    when: #getContents perform: #displayText:;
                    yourself
            );
        yourself
    ).

    v menuWindow
        yourself;
        addMenu: (
            Menu new
                title: 'File';
                owner: self;
                appendItem: 'Open' selector: #openFile;
                appendItem: 'Save' selector: #saveFile
        );
        addMenu: (
            Menu new
                title: 'Customer';
                owner: self;
                appendItem: 'Add' selector: #addCustomer acceleratorString: '';
                appendItem: 'Modify' selector: #modifyCustomer acceleratorString: '';
                appendItem: 'Delete' selector: #deleteCustomer acceleratorString: ''
        );
        addMenu: (
            Menu new
                title: 'Account';
                owner: self;
                appendItem: 'Add Savings' selector: #addSavingsAccount acceleratorString: '';
                appendItem: 'Add Checking' selector: #addCheckingAccount acceleratorString: '';
                appendItem: 'Add Charge' selector: #addChargeAccount acceleratorString: '';
                appendItem: 'Delete' selector: #deleteAccount acceleratorString: ''
        );
        addMenu: (
            Menu new
                title: 'Transaction';
                owner: self;
                appendItem: 'Deposit' selector: #depositTransaction acceleratorString: '';
                appendItem: 'Withdraw' selector: #withdrawTransaction acceleratorString: ''
        );
        addMenu: (
            Menu new
                title: 'End Of Month';
                owner: self;
                appendItem: 'Apply Interest or Charges' selector: #endOfMonthProcessing acceleratorString: ''
        ).!

deleteAccount

    bank removeAcct: selectedAccountNumber.
    selectedAccountNumber := nil.
    self
        changed: #getAccountsList:;
        changed: #displayText:;
        enableDisableMenuItems!

deleteCustomer
    bank removeCus: selectedName.
    selectedName := nil.
    self
        changed: #getAccountList:;
        changed: #getCustomerList:;
        changed: #displayText:;
        enableDisableMenuItems!

depositTransaction
    | amt |
    amt := Prompter prompt: 'Amount' defaultExpression: ''.
    ((amt isNil) | (amt == 0)) ifTrue: [^nil].
    bank at: selectedAccountNumber deposit: amt.
    self changed: #displayText:!

displayText: aPane
    | str |
    selectedName notNil
        ifTrue: [ str := bank customerAsString: selectedName]
        ifFalse: [ selectedAccountNumber notNil
            ifTrue: [str := bank accountAsString: selectedAccountNumber]
            ifFalse: [str := '']].
    aPane contents: str!

enableDisableMenuItems
    | customerMenu accountMenu transactionMenu |
    customerMenu := self menuWindow menuTitled: 'Customer'.
    accountMenu := self menuWindow menuTitled: 'Account'.
    transactionMenu := self menuWindow menuTitled: 'Transaction'.
    selectedName isNil
        ifTrue: [customerMenu disableItem: #deleteCustomer;
                                             disableItem: #modifyCustomer.
                    accountMenu   disableItem: #addSavingsAccount;
                                             disableItem: #addCheckingAccount;
                                             disableItem: #addChargeAccount]
        ifFalse: [customerMenu enableItem: #deleteCustomer;
                                               enableItem: #modifyCustomer.
                    accountMenu     enableItem: #addSavingsAccount;
                                               enableItem: #addCheckingAccount;
                                               enableItem: #addChargeAccount].
    selectedAccountNumber isNil
        ifTrue:   [accountMenu      disableItem: #deleteAccount.
                      transactionMenu disableItem: #depositTransaction;
                                                  disableItem:#withdrawTransaction]
        ifFalse: [accountMenu       enableItem: #deleteAccount.
                      transactionMenu enableItem: #depositTransaction;
                                                   enableItem:#withdrawTransaction]!
  
endOfMonthProcessing
    bank endOfMonthProcessing.
    self changed: #displayText:!
  
getAccountList: aPane
    aPane
        contents: (bank accountNumbers asSortedCollection);
        selection: selectedAccountNumber!

getCustomerList: aPane
    aPane
        contents: (bank customerNames asSortedCollection);
        selection: selectedName!
 
modifyCustomer

    "Callback for the menu item titled 'Modify'.
     (Generated by WindowBuilder)"!
 
openFile
    | dialog   name  fileStream |
    dialog := FileDialog new.
    dialog
        title: 'Open any bank file';
        addFilter: '*.bnk' description: 'Bank Files (*.bnk)';
        defFilter: '*.bnk';
        defExtension: 'bnk'.
    name := dialog open file.
    name isNil
        ifTrue: [^nil].
    CursorManager execute change.
    fileName := name.
    fileStream := File pathName: fileName.
    bank := Bank new.
    bank fileInOn: fileStream.
    fileStream close.
    CursorManager normal change.
    selectedName := nil.
    selectedAccountNumber := nil.
    self
        changed: #getCustomerList:;
        changed: #getAccountList:;
        changed: #displayText:;
        enableDisableMenuItems!
  
openOn: aBank
"Initializes the data structures, sets up
the views, and opens a window on a bank."
    bank := aBank.
    selectedName := nil.
    selectedAccountNumber := nil.
    super open.
    self enableDisableMenuItems!
 
saveFile
"Handles the file/save event."
    | dialog fileStream |
    fileName isNil ifTrue: [
        dialog := FileDialog new.
        dialog
            title: 'Save bank data to file';
            addFilter: '*.bnk' description: 'Bank Files (*.bnk)';
            defFilter: '*.bnk';
            defExtension: 'bnk'.
        fileName := dialog save file.
        fileName isNil
        ifTrue: [^nil]].
    CursorManager execute change.
    fileStream := File newFile: fileName.
    bank fileOutOn: fileStream.
    fileStream truncate; close.
    CursorManager normal change!
 
selectAccount: aPane
"An account has been selected.  Update text pane,
deselect customers, and update menus."
selectedAccountNumber := aPane selectedItem.
    selectedName := nil.
    self
        changed: #displayText:;
        changed: #getCustomerList:;
        enableDisableMenuItems!

selectCustomer: aPane
"A customer has been selected.  Update text pane,
deselect accounts, and update menus."
    selectedName := aPane selectedItem.
    selectedAccountNumber := nil.
    self
        changed: #displayText:;
        changed: #getAccountList:;
        enableDisableMenuItems!
 
withdrawTransaction
    |  amt  |
    amt := Prompter prompt: 'Amount' defaultExpression: ''.
    ((amt isNil) | (amt == 0)) ifTrue: [^nil].
    (bank at: selectedAccountNumber withdraw: amt) = 'not accepted'
        ifTrue: [Menu message: 'Insufficient funds'].
    self changed: #displayText:! !
