
BankAccount subclass: #SavingsAccount
  instanceVariableNames: 
    'minimumBalance '
  classVariableNames: 
    'InterestRate '
  poolDictionaries: ''  !


!SavingsAccount class methods !
  
fileInOn: aStream
"Inputs the savings account's data from aStream."
    | account |
    account := self new.
    account minimumBalance: aStream nextLine asFloat.
    ^account!
   
interestRate: aNumber
    InterestRate := aNumber!
 
new
    ^super new init! !



!SavingsAccount methods !

asString
    ^(super asString, '   minimumBalance: ',
        minimumBalance asDollarsAndCents, '\') withCrs!
 
fileOutOn: aStream
"Outputs the savings account's data to aStream."
    aStream
        nextPutAll: self class name; cr;
        nextPutAll: minimumBalance printString; cr.
    super fileOutOn: aStream!
 
init
    super init.
    minimumBalance := 0.00.
    InterestRate isNil ifTrue: [InterestRate := 0.6]!
   
minimumBalance: aValue
    minimumBalance := aValue!
   
monthlyChargeOrInterest
    | interest |
    interest := minimumBalance * InterestRate / 12.
    balance := balance + interest.
    minimumBalance := balance!
  
withdraw: aNumber
    | outcome |
    outcome := super withdraw: aNumber.
    outcome = 'accepted'
        ifTrue: [minimumBalance := minimumBalance min: balance].
    ^outcome! !
